=== debian/changelog ===
qtwebengine-opensource-src (5.12.4+dfsg-1ubuntu1) eoan; urgency=medium

  * Build with -j2 on arm64.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Fri, 05 Jul 2019 20:54:07 +0300

qtwebengine-opensource-src (5.12.4+dfsg-1) experimental; urgency=medium

  [ Dmitry Shachnev ]
  * Build-depend on binutils ≥ 2.32-8 to fix link failure on amd64.
  * Add a virtual ABI package that the private symbols will depend on.
  * Add Build-Depends-Package field to all symbols files.
  * New upstream release.
  * Drop mips-link-atomic.patch, applied upstream.
  * Refresh run-unbundling-script.patch.
  * Update debian/libqt5webenginecore5.symbols from buildds’ logs.
  * Bump Qt build-dependencies to 5.12.4.
  * Bump Standards-Version to 4.3.0.

  [ Scarlett Moore ]
  * Update my name/email.
  * Update packaging to use doc-base as per policy 9.10.

 -- Dmitry Shachnev <mitya57@debian.org>  Sat, 29 Jun 2019 20:48:15 +0300

qtwebengine-opensource-src (5.12.3+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Link with -latomic on mipsel to fix build failure.
  * Update debian/libqt5webenginecore5.symbols from buildds’ logs.
  * Refresh run-unbundling-script.patch.
  * Bump Qt build-dependencies to 5.12.3.
  * Update symbols files from the current build logs.

 -- Dmitry Shachnev <mitya57@debian.org>  Wed, 01 May 2019 20:31:19 +0300
